diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-header.h ns-3.38/src/internet/model/ipv6-header.h
--- ns-3.37/src/internet/model/ipv6-header.h	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv6-header.h	2023-03-16 20:54:51.628957000 -0700
@@ -229,56 +229,24 @@
     void SetSource(Ipv6Address src);
 
     /**
-     * \brief Set the "Source address" field.
-     * \deprecated Use SetSource () function instead (same functionality)
-     * \param src the source address
-     */
-    NS_DEPRECATED_3_35
-    void SetSourceAddress(Ipv6Address src);
-
-    /**
      * \brief Get the "Source address" field.
      * \return the source address
      */
     Ipv6Address GetSource() const;
 
     /**
-     * \brief Get the "Source address" field.
-     * \deprecated Use GetSource () function instead (same functionality)
-     * \return the source address
-     */
-    NS_DEPRECATED_3_35
-    Ipv6Address GetSourceAddress() const;
-
-    /**
      * \brief Set the "Destination address" field.
      * \param dst the destination address
      */
     void SetDestination(Ipv6Address dst);
 
     /**
-     * \brief Set the "Destination address" field.
-     * \deprecated Use SetDestination () function instead (same functionality)
-     * \param dst the destination address
-     */
-    NS_DEPRECATED_3_35
-    void SetDestinationAddress(Ipv6Address dst);
-
-    /**
      * \brief Get the "Destination address" field.
      * \return the destination address
      */
     Ipv6Address GetDestination() const;
 
     /**
-     * \brief Get the "Destination address" field.
-     * \deprecated Use GetDestination () function instead (same functionality)
-     * \return the destination address
-     */
-    NS_DEPRECATED_3_35
-    Ipv6Address GetDestinationAddress() const;
-
-    /**
      * \brief Print some information about the packet.
      * \param os output stream
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-interface.cc ns-3.38/src/internet/model/ipv6-interface.cc
--- ns-3.37/src/internet/model/ipv6-interface.cc	2022-11-01 17:37:24.499395100 -0700
+++ ns-3.38/src/internet/model/ipv6-interface.cc	2023-03-16 20:54:23.620868400 -0700
@@ -361,7 +361,7 @@
 {
     NS_LOG_FUNCTION(this << address);
 
-    if (address == address.GetLoopback())
+    if (address == Ipv6Address::GetLoopback())
     {
         NS_LOG_WARN("Cannot remove loopback address.");
         return Ipv6InterfaceAddress();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-l3-protocol.cc ns-3.38/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.37/src/internet/model/ipv6-l3-protocol.cc	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/ipv6-l3-protocol.cc	2023-03-16 20:54:23.620868400 -0700
@@ -1292,7 +1292,7 @@
         {
             NS_LOG_LOGIC("Send to gateway " << route->GetGateway());
 
-            if (fragments.size() != 0)
+            if (!fragments.empty())
             {
                 std::ostringstream oss;
 
@@ -1323,7 +1323,7 @@
         {
             NS_LOG_LOGIC("Send to destination " << ipHeader.GetDestination());
 
-            if (fragments.size() != 0)
+            if (!fragments.empty())
             {
                 std::ostringstream oss;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-raw-socket-impl.h ns-3.38/src/internet/model/ipv6-raw-socket-impl.h
--- ns-3.37/src/internet/model/ipv6-raw-socket-impl.h	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/ipv6-raw-socket-impl.h	2023-03-16 20:54:23.620868400 -0700
@@ -170,12 +170,12 @@
     /**
      * \brief IPv6 raw data and additional information.
      */
-    typedef struct
+    struct Data
     {
         Ptr<Packet> packet;    /**< Packet data */
         Ipv6Address fromIp;    /**< Source address */
         uint16_t fromProtocol; /**< Protocol used */
-    } Data;
+    };
 
     /**
      * \brief Dispose object.
@@ -225,10 +225,10 @@
     /**
      * \brief Struct to hold the ICMPv6 filter
      */
-    typedef struct
+    struct Icmpv6Filter
     {
         uint32_t icmpv6Filt[8]; //!< ICMPv6 filter specification
-    } Icmpv6Filter;
+    };
 
     /**
      * \brief ICMPv6 filter.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ipv6-static-routing.cc ns-3.38/src/internet/model/ipv6-static-routing.cc
--- ns-3.37/src/internet/model/ipv6-static-routing.cc	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/ipv6-static-routing.cc	2023-03-16 20:54:23.620868400 -0700
@@ -128,7 +128,7 @@
             // Use not implemented
             *os << "-"
                 << "   ";
-            if (Names::FindName(m_ipv6->GetNetDevice(route.GetInterface())) != "")
+            if (!Names::FindName(m_ipv6->GetNetDevice(route.GetInterface())).empty())
             {
                 *os << Names::FindName(m_ipv6->GetNetDevice(route.GetInterface()));
             }
@@ -458,7 +458,7 @@
                 else
                 {
                     rtentry->SetSource(
-                        m_ipv6->SourceAddressSelection(interfaceIdx, route->GetGateway()));
+                        m_ipv6->SourceAddressSelection(interfaceIdx, route->GetDest()));
                 }
 
                 rtentry->SetDestination(route->GetDest());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ndisc-cache.cc ns-3.38/src/internet/model/ndisc-cache.cc
--- ns-3.37/src/internet/model/ndisc-cache.cc	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/ndisc-cache.cc	2023-03-16 20:54:23.620868400 -0700
@@ -196,7 +196,7 @@
     {
         *os << i->first << " dev ";
         std::string found = Names::FindName(m_device);
-        if (Names::FindName(m_device) != "")
+        if (!Names::FindName(m_device).empty())
         {
             *os << found;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/rip.cc ns-3.38/src/internet/model/rip.cc
--- ns-3.37/src/internet/model/rip.cc	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/rip.cc	2023-03-16 20:54:23.620868400 -0700
@@ -570,7 +570,7 @@
                 // Use not implemented
                 *os << "-"
                     << "   ";
-                if (Names::FindName(m_ipv4->GetNetDevice(route->GetInterface())) != "")
+                if (!Names::FindName(m_ipv4->GetNetDevice(route->GetInterface())).empty())
                 {
                     *os << Names::FindName(m_ipv4->GetNetDevice(route->GetInterface()));
                 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/ripng.cc ns-3.38/src/internet/model/ripng.cc
--- ns-3.37/src/internet/model/ripng.cc	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/ripng.cc	2023-03-16 20:54:23.620868400 -0700
@@ -555,7 +555,7 @@
                 // Use not implemented
                 *os << "-"
                     << "   ";
-                if (Names::FindName(m_ipv6->GetNetDevice(route->GetInterface())) != "")
+                if (!Names::FindName(m_ipv6->GetNetDevice(route->GetInterface())).empty())
                 {
                     *os << Names::FindName(m_ipv6->GetNetDevice(route->GetInterface()));
                 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-bbr.cc ns-3.38/src/internet/model/tcp-bbr.cc
--- ns-3.37/src/internet/model/tcp-bbr.cc	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/tcp-bbr.cc	2023-03-16 20:54:23.624868600 -0700
@@ -131,10 +131,12 @@
     NS_LOG_FUNCTION(this);
 }
 
-const char* const TcpBbr::BbrModeName[BBR_PROBE_RTT + 1] = {"BBR_STARTUP",
-                                                            "BBR_DRAIN",
-                                                            "BBR_PROBE_BW",
-                                                            "BBR_PROBE_RTT"};
+const char* const TcpBbr::BbrModeName[BBR_PROBE_RTT + 1] = {
+    "BBR_STARTUP",
+    "BBR_DRAIN",
+    "BBR_PROBE_BW",
+    "BBR_PROBE_RTT",
+};
 
 void
 TcpBbr::SetStream(uint32_t stream)
@@ -409,7 +411,9 @@
 TcpBbr::HandleProbeRTT(Ptr<TcpSocketState> tcb)
 {
     NS_LOG_FUNCTION(this << tcb);
-    m_appLimited = (m_delivered + tcb->m_bytesInFlight.Get()) ?: 1;
+
+    uint32_t totalBytes = m_delivered + tcb->m_bytesInFlight.Get();
+    m_appLimited = (totalBytes > 0 ? totalBytes : 1);
 
     if (m_probeRttDoneStamp == Seconds(0) && tcb->m_bytesInFlight <= m_minPipeCwnd)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-bbr.h ns-3.38/src/internet/model/tcp-bbr.h
--- ns-3.37/src/internet/model/tcp-bbr.h	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/tcp-bbr.h	2023-03-16 20:54:23.624868600 -0700
@@ -74,13 +74,13 @@
     /**
      * \brief BBR has the following 4 modes for deciding how fast to send:
      */
-    typedef enum
+    enum BbrMode_t
     {
         BBR_STARTUP,   /**< Ramp up sending rate rapidly to fill pipe */
         BBR_DRAIN,     /**< Drain any queue created during startup */
         BBR_PROBE_BW,  /**< Discover, share bw: pace around estimated bw */
         BBR_PROBE_RTT, /**< Cut inflight to min to probe min_rtt */
-    } BbrMode_t;
+    };
 
     typedef WindowedFilter<DataRate,
                            MaxFilter<DataRate>,
@@ -217,18 +217,18 @@
     uint32_t InFlight(Ptr<TcpSocketState> tcb, double gain);
 
     /**
-     * \brief Intializes the full pipe estimator.
+     * \brief Initializes the full pipe estimator.
      */
     void InitFullPipe();
 
     /**
-     * \brief Intializes the pacing rate.
+     * \brief Initializes the pacing rate.
      * \param tcb  the socket state.
      */
     void InitPacingRate(Ptr<TcpSocketState> tcb);
 
     /**
-     * \brief Intializes the round counting related variables.
+     * \brief Initializes the round counting related variables.
      */
     void InitRoundCounting();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-congestion-ops.h ns-3.38/src/internet/model/tcp-congestion-ops.h
--- ns-3.37/src/internet/model/tcp-congestion-ops.h	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/tcp-congestion-ops.h	2023-03-16 20:54:23.624868600 -0700
@@ -88,7 +88,7 @@
      *
      * Is guaranteed that the congestion control state (\p TcpAckState_t) is
      * changed BEFORE the invocation of this method.
-     * The implementator should return the slow start threshold (and not change
+     * The implementer should return the slow start threshold (and not change
      * it directly) because, in the future, the TCP implementation may require to
      * instantly recover from a loss event (e.g. when there is a network with an high
      * reordering factor).
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-cubic.cc ns-3.38/src/internet/model/tcp-cubic.cc
--- ns-3.37/src/internet/model/tcp-cubic.cc	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/tcp-cubic.cc	2023-03-16 20:54:23.624868600 -0700
@@ -62,10 +62,15 @@
                           MakeUintegerChecker<uint32_t>())
             .AddAttribute("HyStartDetect",
                           "Hybrid Slow Start detection mechanisms:"
-                          "1: packet train, 2: delay, 3: both",
-                          IntegerValue(3),
-                          MakeIntegerAccessor(&TcpCubic::m_hystartDetect),
-                          MakeIntegerChecker<int>(1, 3))
+                          "packet train, delay, both",
+                          EnumValue(HybridSSDetectionMode::BOTH),
+                          MakeEnumAccessor(&TcpCubic::m_hystartDetect),
+                          MakeEnumChecker(HybridSSDetectionMode::PACKET_TRAIN,
+                                          "PACKET_TRAIN",
+                                          HybridSSDetectionMode::DELAY,
+                                          "DELAY",
+                                          HybridSSDetectionMode::BOTH,
+                                          "BOTH"))
             .AddAttribute("HyStartMinSamples",
                           "Number of delay samples for detecting the increase of delay",
                           UintegerValue(8),
@@ -341,7 +346,7 @@
 {
     NS_LOG_FUNCTION(this << delay);
 
-    if (!(m_found & m_hystartDetect))
+    if (!m_found)
     {
         Time now = Simulator::Now();
 
@@ -352,7 +357,11 @@
 
             if ((now - m_roundStart) > m_delayMin)
             {
-                m_found |= PACKET_TRAIN;
+                if (m_hystartDetect == HybridSSDetectionMode::PACKET_TRAIN ||
+                    m_hystartDetect == HybridSSDetectionMode::BOTH)
+                {
+                    m_found = true;
+                }
             }
         }
 
@@ -366,18 +375,20 @@
 
             ++m_sampleCnt;
         }
-        else
+        else if (m_currRtt > m_delayMin + HystartDelayThresh(m_delayMin))
         {
-            if (m_currRtt > m_delayMin + HystartDelayThresh(m_delayMin))
+            if (m_hystartDetect == HybridSSDetectionMode::DELAY ||
+                m_hystartDetect == HybridSSDetectionMode::BOTH)
             {
-                m_found |= DELAY;
+                m_found = true;
             }
         }
+
         /*
          * Either one of two conditions are met,
          * we exit from slow start immediately.
          */
-        if (m_found & m_hystartDetect)
+        if (m_found)
         {
             NS_LOG_DEBUG("Exit from SS, immediately :-)");
             tcb->m_ssThresh = tcb->m_cWnd;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-cubic.h ns-3.38/src/internet/model/tcp-cubic.h
--- ns-3.37/src/internet/model/tcp-cubic.h	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/tcp-cubic.h	2023-03-16 20:54:23.624868600 -0700
@@ -70,6 +70,16 @@
 {
   public:
     /**
+     * \brief Values to detect the Slow Start mode of HyStart
+     */
+    enum HybridSSDetectionMode
+    {
+        PACKET_TRAIN = 1, //!< Detection by trains of packet
+        DELAY = 2,        //!< Detection by delay value
+        BOTH = 3,         //!< Detection by both
+    };
+
+    /**
      * \brief Get the type ID.
      * \return the object TypeId
      */
@@ -93,24 +103,15 @@
     Ptr<TcpCongestionOps> Fork() override;
 
   private:
-    /**
-     * \brief Values to detect the Slow Start mode of HyStart
-     */
-    enum HybridSSDetectionMode
-    {
-        PACKET_TRAIN = 0x1, //!< Detection by trains of packet
-        DELAY = 0x2         //!< Detection by delay value
-    };
-
     bool m_fastConvergence; //!< Enable or disable fast convergence algorithm
     double m_beta;          //!< Beta for cubic multiplicative increase
 
-    bool m_hystart;              //!< Enable or disable HyStart algorithm
-    int m_hystartDetect;         //!< Detect way for HyStart algorithm \see HybridSSDetectionMode
-    uint32_t m_hystartLowWindow; //!< Lower bound cWnd for hybrid slow start (segments)
-    Time m_hystartAckDelta;      //!< Spacing between ack's indicating train
-    Time m_hystartDelayMin;      //!< Minimum time for hystart algorithm
-    Time m_hystartDelayMax;      //!< Maximum time for hystart algorithm
+    bool m_hystart;                        //!< Enable or disable HyStart algorithm
+    HybridSSDetectionMode m_hystartDetect; //!< Detect way for HyStart algorithm
+    uint32_t m_hystartLowWindow;           //!< Lower bound cWnd for hybrid slow start (segments)
+    Time m_hystartAckDelta;                //!< Spacing between ack's indicating train
+    Time m_hystartDelayMin;                //!< Minimum time for hystart algorithm
+    Time m_hystartDelayMax;                //!< Maximum time for hystart algorithm
     uint8_t m_hystartMinSamples; //!< Number of delay samples for detecting the increase of delay
 
     uint32_t m_initialCwnd; //!< Initial cWnd
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-header.h ns-3.38/src/internet/model/tcp-header.h
--- ns-3.37/src/internet/model/tcp-header.h	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/tcp-header.h	2023-03-16 20:54:23.624868600 -0700
@@ -275,7 +275,7 @@
     /**
      * \brief TCP flag field values
      */
-    typedef enum
+    enum Flags_t
     {
         NONE = 0, //!< No flags
         FIN = 1,  //!< FIN
@@ -286,7 +286,7 @@
         URG = 32, //!< Urgent
         ECE = 64, //!< ECE
         CWR = 128 //!< CWR
-    } Flags_t;
+    };
 
     /**
      * \brief Get the type ID.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-ledbat.cc ns-3.38/src/internet/model/tcp-ledbat.cc
--- ns-3.37/src/internet/model/tcp-ledbat.cc	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/tcp-ledbat.cc	2023-03-16 20:54:23.624868600 -0700
@@ -150,7 +150,7 @@
 TcpLedbat::MinCircBuf(struct OwdCircBuf& b)
 {
     NS_LOG_FUNCTION_NOARGS();
-    if (b.buffer.size() == 0)
+    if (b.buffer.empty())
     {
         return ~0U;
     }
@@ -242,7 +242,7 @@
 TcpLedbat::AddDelay(struct OwdCircBuf& cb, uint32_t owd, uint32_t maxlen)
 {
     NS_LOG_FUNCTION(this << owd << maxlen << cb.buffer.size());
-    if (cb.buffer.size() == 0)
+    if (cb.buffer.empty())
     {
         NS_LOG_LOGIC("First Value for queue");
         cb.buffer.push_back(owd);
@@ -274,7 +274,7 @@
 TcpLedbat::UpdateBaseDelay(uint32_t owd)
 {
     NS_LOG_FUNCTION(this << owd);
-    if (m_baseHistory.buffer.size() == 0)
+    if (m_baseHistory.buffer.empty())
     {
         AddDelay(m_baseHistory, owd, m_baseHistoLen);
         return;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-option.cc ns-3.38/src/internet/model/tcp-option.cc
--- ns-3.37/src/internet/model/tcp-option.cc	2022-11-01 17:37:24.503395000 -0700
+++ ns-3.38/src/internet/model/tcp-option.cc	2023-03-16 20:54:23.624868600 -0700
@@ -61,23 +61,25 @@
 Ptr<TcpOption>
 TcpOption::CreateOption(uint8_t kind)
 {
-    struct kindToTid
+    struct KindToTid
     {
         TcpOption::Kind kind;
         TypeId tid;
     };
 
     static ObjectFactory objectFactory;
-    static kindToTid toTid[] = {{TcpOption::END, TcpOptionEnd::GetTypeId()},
-                                {TcpOption::MSS, TcpOptionMSS::GetTypeId()},
-                                {TcpOption::NOP, TcpOptionNOP::GetTypeId()},
-                                {TcpOption::TS, TcpOptionTS::GetTypeId()},
-                                {TcpOption::WINSCALE, TcpOptionWinScale::GetTypeId()},
-                                {TcpOption::SACKPERMITTED, TcpOptionSackPermitted::GetTypeId()},
-                                {TcpOption::SACK, TcpOptionSack::GetTypeId()},
-                                {TcpOption::UNKNOWN, TcpOptionUnknown::GetTypeId()}};
+    static KindToTid toTid[] = {
+        {TcpOption::END, TcpOptionEnd::GetTypeId()},
+        {TcpOption::MSS, TcpOptionMSS::GetTypeId()},
+        {TcpOption::NOP, TcpOptionNOP::GetTypeId()},
+        {TcpOption::TS, TcpOptionTS::GetTypeId()},
+        {TcpOption::WINSCALE, TcpOptionWinScale::GetTypeId()},
+        {TcpOption::SACKPERMITTED, TcpOptionSackPermitted::GetTypeId()},
+        {TcpOption::SACK, TcpOptionSack::GetTypeId()},
+        {TcpOption::UNKNOWN, TcpOptionUnknown::GetTypeId()},
+    };
 
-    for (unsigned int i = 0; i < sizeof(toTid) / sizeof(kindToTid); ++i)
+    for (unsigned int i = 0; i < sizeof(toTid) / sizeof(KindToTid); ++i)
     {
         if (toTid[i].kind == kind)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-prr-recovery.h ns-3.38/src/internet/model/tcp-prr-recovery.h
--- ns-3.37/src/internet/model/tcp-prr-recovery.h	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-prr-recovery.h	2023-03-16 20:54:23.624868600 -0700
@@ -64,11 +64,11 @@
     /**
      * \brief Reduction Bound variant (CRB or SSRB)
      */
-    typedef enum
+    enum ReductionBound_t
     {
         CRB, /**< Conservative Reduction Bound */
         SSRB /**< Slow Start Reduction Bound */
-    } ReductionBound_t;
+    };
 
     std::string GetName() const override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-rate-ops.cc ns-3.38/src/internet/model/tcp-rate-ops.cc
--- ns-3.37/src/internet/model/tcp-rate-ops.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-rate-ops.cc	2023-03-16 20:54:23.624868600 -0700
@@ -238,7 +238,7 @@
 }
 
 std::ostream&
-operator<<(std::ostream& os, const TcpRateLinux::TcpRateConnection& rate)
+operator<<(std::ostream& os, const TcpRateOps::TcpRateConnection& rate)
 {
     os << "m_delivered      = " << rate.m_delivered << std::endl;
     os << "m_deliveredTime  = " << rate.m_deliveredTime << std::endl;
@@ -252,7 +252,7 @@
 }
 
 std::ostream&
-operator<<(std::ostream& os, const TcpRateLinux::TcpRateSample& sample)
+operator<<(std::ostream& os, const TcpRateOps::TcpRateSample& sample)
 {
     os << "m_deliveryRate  = " << sample.m_deliveryRate << std::endl;
     os << " m_isAppLimited = " << sample.m_isAppLimited << std::endl;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-rate-ops.h ns-3.38/src/internet/model/tcp-rate-ops.h
--- ns-3.37/src/internet/model/tcp-rate-ops.h	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-rate-ops.h	2023-03-16 20:54:23.624868600 -0700
@@ -247,7 +247,7 @@
   private:
     // Rate sample related variables
     TcpRateConnection m_rate;   //!< Rate information
-    TcpRateSample m_rateSample; //!< Rate sample (continuosly updated)
+    TcpRateSample m_rateSample; //!< Rate sample (continuously updated)
 
     TracedCallback<const TcpRateConnection&> m_rateTrace;   //!< Rate trace
     TracedCallback<const TcpRateSample&> m_rateSampleTrace; //!< Rate Sample trace
@@ -259,7 +259,7 @@
  * \param sample the TcpRateLinux::TcpRateSample to print.
  * \returns The output stream.
  */
-std::ostream& operator<<(std::ostream& os, const TcpRateLinux::TcpRateSample& sample);
+std::ostream& operator<<(std::ostream& os, const TcpRateOps::TcpRateSample& sample);
 
 /**
  * \brief Output operator.
@@ -267,7 +267,7 @@
  * \param rate the TcpRateLinux::TcpRateConnection to print.
  * \returns The output stream.
  */
-std::ostream& operator<<(std::ostream& os, const TcpRateLinux::TcpRateConnection& rate);
+std::ostream& operator<<(std::ostream& os, const TcpRateOps::TcpRateConnection& rate);
 
 /**
  * Comparison operator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-rx-buffer.cc ns-3.38/src/internet/model/tcp-rx-buffer.cc
--- ns-3.37/src/internet/model/tcp-rx-buffer.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-rx-buffer.cc	2023-03-16 20:54:23.624868600 -0700
@@ -117,7 +117,7 @@
     { // No data allowed beyond FIN
         return m_finSeq;
     }
-    else if (m_data.size() && m_nextRxSeq > m_data.begin()->first)
+    else if (!m_data.empty() && m_nextRxSeq > m_data.begin()->first)
     { // No data allowed beyond Rx window allowed
         return m_data.begin()->first + SequenceNumber32(m_maxBuffer);
     }
@@ -159,7 +159,7 @@
     {
         headSeq = m_nextRxSeq;
     }
-    if (m_data.size())
+    if (!m_data.empty())
     {
         SequenceNumber32 maxSeq = m_data.begin()->first + SequenceNumber32(m_maxBuffer);
         if (maxSeq < tailSeq)
@@ -388,7 +388,7 @@
     {
         return nullptr; // No contiguous block to return
     }
-    NS_ASSERT(m_data.size());              // At least we have something to extract
+    NS_ASSERT(!m_data.empty());            // At least we have something to extract
     Ptr<Packet> outPkt = Create<Packet>(); // The packet that contains all the data to return
     BufIterator i;
     while (extractSize)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-rx-buffer.h ns-3.38/src/internet/model/tcp-rx-buffer.h
--- ns-3.37/src/internet/model/tcp-rx-buffer.h	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-rx-buffer.h	2023-03-16 20:54:23.624868600 -0700
@@ -140,7 +140,7 @@
     /**
      * Insert a packet into the buffer and update the availBytes counter to
      * reflect the number of bytes ready to send to the application. This
-     * function handles overlap by triming the head of the inputted packet and
+     * function handles overlap by trimming the head of the inputted packet and
      * removing data from the buffer that overlaps the tail of the inputted
      * packet
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-socket-base.h ns-3.38/src/internet/model/tcp-socket-base.h
--- ns-3.37/src/internet/model/tcp-socket-base.h	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-socket-base.h	2023-03-16 20:54:23.624868600 -0700
@@ -376,28 +376,28 @@
      * \param oldValue old pacing rate value
      * \param newValue new pacing rate value
      */
-    void UpdatePacingRateTrace(DataRate oldValue, DataRate newValue);
+    void UpdatePacingRateTrace(DataRate oldValue, DataRate newValue) const;
 
     /**
      * \brief Callback function to hook to TcpSocketState congestion window
      * \param oldValue old cWnd value
      * \param newValue new cWnd value
      */
-    void UpdateCwnd(uint32_t oldValue, uint32_t newValue);
+    void UpdateCwnd(uint32_t oldValue, uint32_t newValue) const;
 
     /**
      * \brief Callback function to hook to TcpSocketState inflated congestion window
      * \param oldValue old cWndInfl value
      * \param newValue new cWndInfl value
      */
-    void UpdateCwndInfl(uint32_t oldValue, uint32_t newValue);
+    void UpdateCwndInfl(uint32_t oldValue, uint32_t newValue) const;
 
     /**
      * \brief Callback function to hook to TcpSocketState slow start threshold
      * \param oldValue old ssTh value
      * \param newValue new ssTh value
      */
-    void UpdateSsThresh(uint32_t oldValue, uint32_t newValue);
+    void UpdateSsThresh(uint32_t oldValue, uint32_t newValue) const;
 
     /**
      * \brief Callback function to hook to TcpSocketState congestion state
@@ -405,42 +405,43 @@
      * \param newValue new congestion state value
      */
     void UpdateCongState(TcpSocketState::TcpCongState_t oldValue,
-                         TcpSocketState::TcpCongState_t newValue);
+                         TcpSocketState::TcpCongState_t newValue) const;
 
     /**
      * \brief Callback function to hook to EcnState state
      * \param oldValue old ecn state value
      * \param newValue new ecn state value
      */
-    void UpdateEcnState(TcpSocketState::EcnState_t oldValue, TcpSocketState::EcnState_t newValue);
+    void UpdateEcnState(TcpSocketState::EcnState_t oldValue,
+                        TcpSocketState::EcnState_t newValue) const;
 
     /**
      * \brief Callback function to hook to TcpSocketState high tx mark
      * \param oldValue old high tx mark
      * \param newValue new high tx mark
      */
-    void UpdateHighTxMark(SequenceNumber32 oldValue, SequenceNumber32 newValue);
+    void UpdateHighTxMark(SequenceNumber32 oldValue, SequenceNumber32 newValue) const;
 
     /**
      * \brief Callback function to hook to TcpSocketState next tx sequence
      * \param oldValue old nextTxSeq value
      * \param newValue new nextTxSeq value
      */
-    void UpdateNextTxSequence(SequenceNumber32 oldValue, SequenceNumber32 newValue);
+    void UpdateNextTxSequence(SequenceNumber32 oldValue, SequenceNumber32 newValue) const;
 
     /**
      * \brief Callback function to hook to TcpSocketState bytes inflight
      * \param oldValue old bytesInFlight value
      * \param newValue new bytesInFlight value
      */
-    void UpdateBytesInFlight(uint32_t oldValue, uint32_t newValue);
+    void UpdateBytesInFlight(uint32_t oldValue, uint32_t newValue) const;
 
     /**
      * \brief Callback function to hook to TcpSocketState rtt
      * \param oldValue old rtt value
      * \param newValue new rtt value
      */
-    void UpdateRtt(Time oldValue, Time newValue);
+    void UpdateRtt(Time oldValue, Time newValue) const;
 
     /**
      * \brief Install a congestion control algorithm on this socket
@@ -577,9 +578,9 @@
     void SetPaceInitialWindow(bool paceWindow);
 
     // Necessary implementations of null functions from ns3::Socket
-    enum SocketErrno GetErrno() const override;     // returns m_errno
-    enum SocketType GetSocketType() const override; // returns socket type
-    Ptr<Node> GetNode() const override;             // returns m_node
+    SocketErrno GetErrno() const override;     // returns m_errno
+    SocketType GetSocketType() const override; // returns socket type
+    Ptr<Node> GetNode() const override;        // returns m_node
     int Bind() override;  // Bind a socket by setting up endpoint in TcpL4Protocol
     int Bind6() override; // Bind a socket by setting up endpoint in TcpL4Protocol
     int Bind(const Address& address) override; // ... endpoint of specific addr or port
@@ -1323,10 +1324,7 @@
     // State-related attributes
     TracedValue<TcpStates_t> m_state{CLOSED}; //!< TCP state
 
-    mutable enum SocketErrno m_errno
-    {
-        ERROR_NOTERROR
-    }; //!< Socket error code
+    mutable SocketErrno m_errno{ERROR_NOTERROR}; //!< Socket error code
 
     bool m_closeNotified{false}; //!< Told app to close socket
     bool m_closeOnEmpty{false};  //!< Close socket upon tx buffer emptied
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-socket.cc ns-3.38/src/internet/model/tcp-socket.cc
--- ns-3.37/src/internet/model/tcp-socket.cc	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-socket.cc	2023-03-16 20:54:23.624868600 -0700
@@ -36,17 +36,19 @@
 
 NS_OBJECT_ENSURE_REGISTERED(TcpSocket);
 
-const char* const TcpSocket::TcpStateName[TcpSocket::LAST_STATE] = {"CLOSED",
-                                                                    "LISTEN",
-                                                                    "SYN_SENT",
-                                                                    "SYN_RCVD",
-                                                                    "ESTABLISHED",
-                                                                    "CLOSE_WAIT",
-                                                                    "LAST_ACK",
-                                                                    "FIN_WAIT_1",
-                                                                    "FIN_WAIT_2",
-                                                                    "CLOSING",
-                                                                    "TIME_WAIT"};
+const char* const TcpSocket::TcpStateName[TcpSocket::LAST_STATE] = {
+    "CLOSED",
+    "LISTEN",
+    "SYN_SENT",
+    "SYN_RCVD",
+    "ESTABLISHED",
+    "CLOSE_WAIT",
+    "LAST_ACK",
+    "FIN_WAIT_1",
+    "FIN_WAIT_2",
+    "CLOSING",
+    "TIME_WAIT",
+};
 
 TypeId
 TcpSocket::GetTypeId()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet/model/tcp-socket.h ns-3.38/src/internet/model/tcp-socket.h
--- ns-3.37/src/internet/model/tcp-socket.h	2022-11-01 17:37:24.507395000 -0700
+++ ns-3.38/src/internet/model/tcp-socket.h	2023-03-16 20:54:23.624868600 -0700
@@ -62,7 +62,7 @@
      * \brief Names of the 11 TCP states
      *
      */
-    typedef enum
+    enum TcpStates_t
     {
         CLOSED = 0,  /**< Socket is finished                                     */
         LISTEN,      /**< Listening for a connection                             */
@@ -87,7 +87,7 @@
                       *  may not have gotten our last ACK causing it
                       *  to retransmit the data packet (which we ignore)        */
         LAST_STATE   /**< Last state, used only in debug messages                */
-    } TcpStates_t;
+    };
 
     /**
      * \brief Literal names of TCP states for use in log messages
